#pragma once

#include <limits>
#include <assert.h>
#include <string.h>

#ifdef WIN32
#define _USE_MATH_DEFINES
#endif
#include <math.h>

#include "pvc_image.h"
#include "pvc_image_gray.h"

using namespace std;

class PVC_Kernel:public PVC_Image
{
protected: 
  int halfsize_value;

public: 
  
  
  void resize ( int width, int height );

  int halfsize(){ return halfsize_value; };

  /* index */
  inline float get_value( int x, int y ){ return data [ ( y + halfsize_value ) * w() + x + halfsize_value ]; }
  inline void  put_value( int x, int y, float value ){ data [ ( y + halfsize_value ) * w() + x + halfsize_value ] = value; }

};


class Filter_Image:public PVC_Image
{
public:
  float get_value( int x, int y, int channel ){ return data [ ( y * w() + x ) * 4 + channel ]; }
  float put_value( int x, int y, int channel, float value ){ data [ ( y * w() + x ) * 4 + channel ] = value; }

  float *get_data(){return data;}

  /*! convolve with convolution filter defined as kernel image */
  virtual Filter_Image *filterGauss( float SIGMA ) = 0;

  /*! takes another color images; both images are converted to gray and substracted; gray image is returned */
  PVC_Image_Gray *substractToGray( Filter_Image* im );

  /*! normalize image to [0,1] */
  void normalize();

};
